"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
require("core-js/modules/web.dom-collections.iterator.js");
var _react = _interopRequireWildcard(require("react"));
var _styledComponents = _interopRequireWildcard(require("styled-components"));
var _templateObject, _templateObject2, _templateObject3, _templateObject4;
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
const TypewriterAnimation = _ref => {
  let {
    value,
    blinkTimer,
    containerMargin,
    containerPadding,
    containerBgColor,
    containerAlignItems,
    containerJustifyContent,
    containerHeight,
    headerColor,
    headerFontSize,
    headerFontFamily,
    headerMargin,
    headerPadding,
    descColor,
    descFontSize,
    descFontFamily,
    descMargin,
    descPadding
  } = _ref;
  const [name, setName] = (0, _react.useState)("");
  const [display, setDisplay] = (0, _react.useState)(true);
  const setNameAnimation = (0, _react.useCallback)(value => {
    // alert(display);
    let index = 0,
      s = [];
    const g = setInterval(function () {
      index = index + 1;
      if (s.length <= value.length) {
        // s.pop();
        s.push(value[index - 1]);
        // s.push(" _");
        if (value[index - 1] === ".") {}
        setName(s.join("").split("."));
      }
    }, 100);
    if (s.length === value.length) {
      clearInterval(g);
    }
  }, []);
  (0, _react.useEffect)(() => {
    setTimeout(() => {
      setDisplay(false);
    }, blinkTimer);
  }, [display, setDisplay, value, blinkTimer]);
  (0, _react.useEffect)(() => {
    setNameAnimation(value);
  }, [setNameAnimation, value]);
  const AnimationWrapper = _styledComponents.default.header(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n    margin: ", ";\n    background-color: ", ";\n    padding: ", ";\n    display: flex;\n    align-items: ", ";\n    justify-content: ", ";\n    height: ", ";\n\n    h1 {\n      color: ", ";\n      font-size: ", ";\n      font-family: ", ";\n      margin: ", ";\n      padding: ", ";\n    }\n\n    p {\n      // display: flex;\n      // justify-content: start;\n      color: ", ";\n      font-size: ", ";\n      font-family: ", ";\n      margin: ", ";\n      padding: ", ";\n    }\n  "])), props => props.containerMargin || "0%", props => props.containerBgColor || "#48c9b0", props => props.containerPadding || "0%", props => props.containerAlignItems || "start", props => props.containerJustifyContent || "start", props => props.containerHeight || "auto", props => props.headerColor || "white", props => props.headerFontSize || "5em", props => props.headerFontFamily || "system-ui", props => props.headerMargin || "0%", props => props.headerPadding || "0%", props => props.descColor || "black", props => props.descFontSize || "4em", props => props.descFontFamily || "system-ui", props => props.descMargin || "0.1em 0.1em 0.1em 0.1em", props => props.descPadding || "0.1em 0.1em 0.1em 0.1em");
  const Blinker_ = _styledComponents.default.span(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  position: relative;\n  width: 10px;\n  height: 90px;\n  margin:0px 0px 0px 10px;\n  &:before,\n  &:after {\n    position: absolute;\n    content: '';\n    // left: 50px;\n    top: 0;\n   \n    width: 5px;\n    height: 80px;\n    background: black;\n    // border-radius: 0px 0px 0 0;\n    // transform: rotate(-45deg);\n    // transform-origin: 0 100%;\n  }\n \n    }\n  "])));
  const blink = (0, _styledComponents.keyframes)(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n\n  60%\n  {\n    opacity: 0;\n  }\n  \n"])));
  const Blinker = (0, _styledComponents.default)(Blinker_)(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n    animation: ", " 1s infinite;\n  "])), blink);
  return /*#__PURE__*/_react.default.createElement(AnimationWrapper, {
    containerMargin: containerMargin,
    containerPadding: containerPadding,
    containerBgColor: containerBgColor,
    containerAlignItems: containerAlignItems,
    containerJustifyContent: containerJustifyContent,
    containerHeight: containerHeight,
    headerColor: headerColor,
    headerFontSize: headerFontSize,
    headerFontFamily: headerFontFamily,
    headerMargin: headerMargin,
    headerPadding: headerPadding,
    descColor: descColor,
    descFontSize: descFontSize,
    descFontFamily: descFontFamily,
    descMargin: descMargin,
    descPadding: descPadding
  }, /*#__PURE__*/_react.default.createElement("table", null, /*#__PURE__*/_react.default.createElement("tbody", null, Array.from(Array(name.length).keys()).map((e, i) => i === 0 ? /*#__PURE__*/_react.default.createElement("tr", {
    key: i
  }, /*#__PURE__*/_react.default.createElement("td", null, /*#__PURE__*/_react.default.createElement("h1", null, name[i]))) : i === 1 ? /*#__PURE__*/_react.default.createElement("tr", {
    key: i
  }, /*#__PURE__*/_react.default.createElement("td", null, /*#__PURE__*/_react.default.createElement("p", {
    key: i,
    id: "description".concat(i)
  }, name[i], /*#__PURE__*/_react.default.createElement("span", {
    style: {
      visibility: display ? "visible" : "hidden"
    }
  }, /*#__PURE__*/_react.default.createElement(Blinker, null, display))))) : ""))));
};
var _default = TypewriterAnimation;
exports.default = _default;